X-Git-Url: https://git.p6c8.net/nextcloud-backup-restore.git/blobdiff_plain/c560d693f1d4e3f6b842f776a2d7d6a187c5f4c3..802fec8fdc49996073c931007173919479d4d6b0:/NextcloudBackup.sh?ds=sidebyside

diff --git a/NextcloudBackup.sh b/NextcloudBackup.sh
index 38de995..f1e591b 100644
--- a/NextcloudBackup.sh
+++ b/NextcloudBackup.sh
@@ -3,8 +3,8 @@
 #
 # Bash script for creating backups of Nextcloud.
 # Usage: ./NextcloudBackup.sh
-# 
-# The script is based on an installation of Nextcloud using nginx and MariaDB, see https://decatec.de/home-server/nextcloud-auf-ubuntu-server-mit-nginx-mariadb-php-lets-encrypt-redis-und-fail2ban/
+#
+# The script is based on an installation of Nextcloud using nginx and MariaDB, see https://decatec.de/home-server/nextcloud-auf-ubuntu-server-18-04-lts-mit-nginx-mariadb-php-lets-encrypt-redis-und-fail2ban/
 #
 
 #
@@ -17,7 +17,7 @@
 currentDate=$(date +"%Y%m%d_%H%M%S")
 # TODO: The directory where you store the Nextcloud backups
 backupMainDir="/mnt/Share/NextcloudBackups/"
-# The actual directory of the current backup - this is is subdirectory of the main directory above with a timestamp
+# The actual directory of the current backup - this is a subdirectory of the main directory above with a timestamp
 backupdir="${backupMainDir}/${currentDate}/"
 # TODO: The directory of your Nextcloud installation (this is a directory under your web root)
 nextcloudFileDir="/var/www/nextcloud"
@@ -46,6 +46,32 @@ fileNameBackupDb="nextcloud-db.sql"
 # Function for error messages
 errorecho() { cat <<< "$@" 1>&2; }
 
+function DisableMaintenanceMode() {
+	echo "Switching off maintenance mode..."
+	cd "${nextcloudFileDir}"
+	sudo -u "${webserverUser}" php occ maintenance:mode --off
+	cd ~
+	echo "Done"
+	echo
+}
+
+# Capture CTRL+C
+trap CtrlC INT
+
+function CtrlC() {
+	read -p "Backup cancelled. Keep maintenance mode? [y/n] " -n 1 -r
+	echo
+
+	if ! [[ $REPLY =~ ^[Yy]$ ]]
+	then
+		DisableMaintenanceMode
+	else
+		echo "Maintenance mode still enabled."
+	fi
+
+	exit 1
+}
+
 #
 # Check for root
 #
@@ -116,29 +142,24 @@ echo
 #
 # Disable maintenance mode
 #
-echo "Switching off maintenance mode..."
-cd "${nextcloudFileDir}"
-sudo -u "${webserverUser}" php occ maintenance:mode --off
-cd ~
-echo "Done"
-echo
+DisableMaintenanceMode()
 
 #
 # Delete old backups
 #
-if [ ${maxNrOfBackups} != 0 ]
-then	
+if (( ${maxNrOfBackups} != 0 ))
+then
 	nrOfBackups=$(ls -l ${backupMainDir} | grep -c ^d)
-	
-	if [  ${maxNrOfBackups} > ${nrOfBackups} ]
+
+	if (( ${nrOfBackups} > ${maxNrOfBackups} ))
 	then
 		echo "Removing old backups..."
 		ls -t ${backupMainDir} | tail -$(( nrOfBackups - maxNrOfBackups )) | while read dirToRemove; do
-		echo "${dirToRemove}"
-		rm -r ${backupMainDir}/${dirToRemove}
-		echo "Done"
-		echo
-    done
+			echo "${dirToRemove}"
+			rm -r ${backupMainDir}/${dirToRemove}
+			echo "Done"
+			echo
+		done
 	fi
 fi